
#include "scanner.h"
#include "parsing.h"
#include "table.h"
#include "dal_c_lookups.h"
#include "Interpreter.h"

//#include "PerlInterpreter.h"
//#include "param.h"
//#include "SasFileLocator.h"
//#include "dscript.h"


//static string systemPerllib = "systemPerllib";
//static string perllib = "perllib";
//static string infile = "infile";
//static string _optional_ = "_optional_";


static void
test( const string& fileName )
{
	// *************************************************
	// Initialise the Perl interpreter so that deceit.pl
	// perl source file is read.
	// The default is used if the user has not specified
	// it on the command line.
	// *************************************************
	//if( stringParameter( perllib ) == _optional_ )
	//{
	//	perlInterpreter.initialise( fileLocator.locate( stringParameter( systemPerllib )));
	//}
	//else
	//{
	//	perlInterpreter.initialise( stringParameter( perllib ));
	//} // if

	//string fileName = stringParameter( infile );

	ScannerT	scanner( fileName );
	TableT		lookupTable;
	//perlInterpreter.addFunctionsToTable( lookupTable );
	interpreter.addFunctionsToTable( lookupTable );
	lookupTable.append( dalCLookups() );

	while( !scanner.EndOfFile() )
	{
		Token::BTree expression = ParseStatement( scanner );
		interpreter.EvaluateExpression( expression, lookupTable );

	} // while

}


int
main( int argc, char** argv)
{
	for( int i = 1; i < argc; ++i )
	{
		test( argv[ i ] );
	} // for

	return 0;
}


